## cpptraj 5.1.0%2Bdfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1) #need 3.1 for "cmake -E env" command
project(cpptraj NONE)

#version number
#---------------------------------------------------------------------------------------------------------------------------------------------------------------------
set(cpptraj_MAJOR_VERSION 4)
set(cpptraj_MINOR_VERSION 3)
set(cpptraj_TWEAK_VERSION 4)

set(cpptraj_VERSION "${cpptraj_MAJOR_VERSION}.${cpptraj_MINOR_VERSION}.${cpptraj_TWEAK_VERSION}")

if(NOT INSIDE_AMBER)
	# initialization and include paths
	#---------------------------------------------------------------------------------------------------------------------------------------------------------------------
	include(cmake/AmberBuildSystemInit.cmake)

	#now enable the languages
	enable_language(C CXX)

	include(AmberBuildSystem2ndInit)
	
	include(OpenMPConfig)
	include(MPIConfig)
	include(CudaConfig)

	set(LINALG_LIBS_REQUIRED TRUE)
	set(NEEDED_3RDPARTY_TOOLS zlib fftw libbz2 readline pnetcdf blas lapack mkl arpack netcdf)
	set(REQUIRED_3RDPARTY_TOOLS netcdf)
	include(3rdPartyTools)
	
	if(fftw_DISABLED)
		enable_language(Fortran)
	endif()
	
	include(CompilerFlags)

	include(NetlibConfig)
	
	#CPack setup
	# --------------------------------------------------------------------
	set(PACKAGE_NAME "cpptraj")
	set(PACKAGE_FILENAME "cpptraj")

	#set(ICO_ICON ${CMAKE_SOURCE_DIR}/amber.ico)
	#set(ICO_UNINSTALL_ICON ${CMAKE_SOURCE_DIR}/amber-uninstall.ico)
	#set(ICNS_ICON ${CMAKE_SOURCE_DIR}/cmake-packaging/amber_logo.icns)
	#set(OSX_STARTUP_SCRIPT ${CMAKE_SOURCE_DIR}/cmake-packaging/osx-startup-script.sh)
	set(BUNDLE_IDENTIFIER org.ambermd.cpptraj)
	set(BUNDLE_SIGNATURE CPTJ)
	include(Packaging)
	
	# header installation option
	option(INSTALL_HEADERS "Copy headers to the include/cpptraj folder of the install directory.  Useful for building with pytraj." FALSE)
	
	option(BUILD_PARALLEL_COMBINATIONS "If true, then combinations of all enabled parallelizations will be built, e.g. cpptraj.OMP.MPI and cpptraj.OMP.MPI.cuda" FALSE)
else()
	set(INSTALL_HEADERS FALSE)
	set(BUILD_PARALLEL_COMBINATIONS FALSE)
endif()

# on Windows, make MSVC auto-create import libraries just like MinGW does
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

add_subdirectory(src)
add_subdirectory(test)

#--------------------------------------------------------------	
if(NOT INSIDE_AMBER)
	print_build_report()
endif()

=== debian/changelog ===
cpptraj (5.1.0+dfsg-3build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:39:12 +1100

cpptraj (5.1.0+dfsg-3build2) noble; urgency=medium

  * No-change rebuild against libarpack2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 07:32:53 +0000

cpptraj (5.1.0+dfsg-3build1) mantic; urgency=medium

  * Rebuild against latest openmm

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 27 Jun 2023 14:04:24 -0400

cpptraj (5.1.0+dfsg-3) unstable; urgency=medium

  * Build with OpenMM on platforms which support OpenMM.
  * Build with libfftw3-dev.
  * Skip one more test case.

 -- Andrius Merkys <merkys@debian.org>  Thu, 24 Nov 2022 10:08:51 -0500

cpptraj (5.1.0+dfsg-2) unstable; urgency=medium

  * Adjust debian/watch to ignore old two-digit year number-based tags.
  * Run unittest during build.
  * Add autopkgtest.

 -- Andrius Merkys <merkys@debian.org>  Wed, 17 Aug 2022 02:50:24 -0400

cpptraj (5.1.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1017000)

 -- Andrius Merkys <merkys@debian.org>  Thu, 11 Aug 2022 03:14:45 -0400

## cpptraj 5.1.0+dfsg

=== Makefile ===
# CPPTRAJ - Main makefile
# Daniel R. Roe
# 2014-12-10

# Make all targets
all: install

# Install all targets 
install: config.h
	cd src && $(MAKE) install

# Create libcpptraj.so
libcpptraj: config.h
	cd src && $(MAKE) libcpptraj

# Create static libraries
libstatic: config.h
	cd src && $(MAKE) libstatic

# Run Tests
check: config.h
	cd test && $(MAKE) test.complete summary

unittest: config.h
	cd unitTests && $(MAKE) test.complete summary

# Clean up
clean: config.h
	cd src && $(MAKE) clean
	cd test && $(MAKE) clean
	cd unitTests && $(MAKE) clean

docs: src/cpptraj.Doxyfile
	cd src && doxygen cpptraj.Doxyfile

# Remove cpptraj binary
uninstall: config.h
	cd src && $(MAKE) uninstall

=== src/CMakeLists.txt ===
add_subdirectory(xdrfile)

#---------------------------------------------------------------------------------------------------------------------------------------------------------------------
# Parse cpptrajfiles

# read each non-empty line into an element of a list
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/cpptrajfiles CPPTRAJFILES_CONTENTS)

# get rid of backslashes
string(REPLACE "\\" "" CPPTRAJFILES_CONTENTS "${CPPTRAJFILES_CONTENTS}")

# name of list that we are curreently appending to
set(LIST_NAME "")

foreach(LINE ${CPPTRAJFILES_CONTENTS})

	# ignore comment lines
	if(NOT "${LINE}" MATCHES "^#")

		# extract the name of the source file mentioned in the line (a string after whitespace or an equals sign)
		string(REGEX MATCH "[^ :=]+\.(cpp|c|LIBCPPTRAJ\.o)" SOURCE_FILE_NAME "${LINE}")
		
		# get name of variable that the following list is being set to
		# must exclude parentheses so that we don't match dereferences of other variables
		string(REGEX MATCH "[^$\(\)]+=" VARIABLE_NAME "${LINE}")
		
		# if we are starting a new source list, update LIST_NAME accordingly
		if(NOT "${VARIABLE_NAME}" STREQUAL "")
			string(REPLACE "=" "" VARIABLE_NAME "${VARIABLE_NAME}")
			set(LIST_NAME ${VARIABLE_NAME})
		endif()
		
		# did we get a new source file?
		if(NOT "${SOURCE_FILE_NAME}" STREQUAL "")
			
			if("${LIST_NAME}" STREQUAL "")
				message(FATAL_ERROR "cpptrajfiles parser error: got source files before any source lists!")
			endif()
			
			# get rid of LIBCPPTRAJ.o suffix if it exists
			string(REPLACE "LIBCPPTRAJ.o" "cpp" SOURCE_FILE_NAME "${SOURCE_FILE_NAME}")
			
			
			list(APPEND ${LIST_NAME} ${SOURCE_FILE_NAME})
		endif()
			
		#message("\"${LINE}\" - SFN: \"${SOURCE_FILE_NAME}\" - VN: \"${VARIABLE_NAME}\"")
	endif()
endforeach()

# The above loop will create the folowing variables:
# COMMON_SOURCES - all C++ source files used for both cpptraj and libcpptraj, that are compiled the same way for both
# CSOURCES - all C source files used for cpptraj and libcpptraj
# SOURCES - C++ sources for cpptraj only
# LIBCPPTRAJ_OBJECTS - C++ sources for libcpptraj that should be compiled with the LIBCPPTRAJ definition 

# pub_fft.F90 is not in the source lists
set(PUBFFT_FORTRAN_SOURCE pub_fft.F90)

#---------------------------------------------------------------------------------------------------------------------------------------------------------------------

set_property(SOURCE ${PUBFFT_FORTRAN_SOURCE} PROPERTY COMPILE_FLAGS "${OPT_FFLAGS_SPC}")
set_property(SOURCE ${COMMON_SOURCES} ${SOURCES} ${LIBCPPTRAJ_OBJECTS} PROPERTY COMPILE_FLAGS "${OPT_CXXFLAGS_SPC}")
set_property(SOURCE ${CSOURCES} PROPERTY COMPILE_FLAGS "${OPT_CFLAGS_SPC}")

include_directories(${AMBERTOOLS_INC_DIR})

if(fftw_ENABLED)	
	set_property(SOURCE PubFFT.cpp PROPERTY COMPILE_DEFINITIONS FFTW_FFT)
endif()

#---------------------------------------------------------------------------------------------------------------------------------------------------------------------
#add the common object library

#concatenate all the source files
set(CPPTRAJ_COMMON_SOURCES ${COMMON_SOURCES} ${CSOURCES})

if(fftw_DISABLED)
	# we only need pubfft if we don't have FFTW
	list(APPEND CPPTRAJ_COMMON_SOURCES ${PUBFFT_FORTRAN_SOURCE})
endif()

add_library(cpptraj_common_obj OBJECT ${CPPTRAJ_COMMON_SOURCES})
make_pic_if_needed(cpptraj_common_obj)

#normally this would be applied by target_link_libraries, but since we use that intermediary object library, we have to apply it manually

# NOTE: there is a CMake bug where if we were to set these as a directory-scope includes, the CUDA build would fail on some platforms with old versions of CMake
# it turns out that CMake's cuda library passes the include paths after the first one from each of these generator expressions to nvcc without the -I flag
# This causes the error "A single input file is required for a non-link phase when an outputfile is specified"
target_include_directories(cpptraj_common_obj PRIVATE $<TARGET_PROPERTY:xdrfile,INTERFACE_INCLUDE_DIRECTORIES> $<TARGET_PROPERTY:netcdf,INTERFACE_INCLUDE_DIRECTORIES>)
 
#---------------------------------------------------------------------------------------------------------------------------------------------------------------------
# cpptraj executable

add_executable(cpptraj $<TARGET_OBJECTS:cpptraj_common_obj> ${SOURCES})

target_link_libraries(cpptraj netcdf netlib)

install(TARGETS cpptraj DESTINATION ${BINDIR})
#------------------------------------------------------------------------------------------
# libcpptraj library

add_library(libcpptraj $<TARGET_OBJECTS:cpptraj_common_obj> ${LIBCPPTRAJ_OBJECTS})
set_property(TARGET libcpptraj PROPERTY COMPILE_DEFINITIONS LIBCPPTRAJ)

target_link_libraries(libcpptraj netcdf netlib)
remove_prefix(libcpptraj)
install_libraries(libcpptraj)

#tell others where to find the cpptraj includes
target_include_directories(libcpptraj INTERFACE .)

#------------------------------------------------------------------------------------------
# DLL exports/imports

if(SHARED)
	# CMake automatically sets up the libcpptraj_EXPORTS definition for libcpptraj.
	# We just have to apply it to the common obj as well.
	target_compile_definitions(cpptraj_common_obj PRIVATE libcpptraj_EXPORTS)

	# now set up the definition for other people to use
	target_compile_definitions(libcpptraj INTERFACE CPPTRAJ_USE_DLL)
endif()

#------------------------------------------------------------------------------------------
# Header installation

if(INSTALL_HEADERS)
	# grab all .h files from the main directory.
	file(GLOB CPPTRAJ_HEADERS "*.h")
	list(REMOVE_ITEM CPPTRAJ_HEADERS "SymbolExporting.h")
	
	# also grab xdrfile headers since some of them are used by cpptraj headers
	file(GLOB XDRFILE_HEADERS "xdrfile/*.h")

	install(FILES ${CPPTRAJ_HEADERS} DESTINATION ${INCDIR}/cpptraj)
	install(FILES ${XDRFILE_HEADERS} DESTINATION ${INCDIR}/cpptraj/xdrfile)
	
	# configure SymbolExporting.h specially for the current install type
	if(SHARED)
		set(CPPTRAJ_IS_SHARED 1)
	else()
		set(CPPTRAJ_IS_SHARED 0)
	endif()
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/SymbolExporting-installversion.h.in ${CMAKE_CURRENT_BINARY_DIR}/SymbolExporting-installversion.h @ONLY)
	
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SymbolExporting-installversion.h DESTINATION ${INCDIR}/cpptraj RENAME SymbolExporting.h)
	
endif()

#---------------------------------------------------------------------------------------------------------------------------------------------------------------------
#Deal with external libraries

# NOTE: you CANNOT set any directory-scope include directories that use generator expressions here.
# These expressions get propagated down into the cuda_kernels subdir, and trigger an undocumented bug in old versions of CMake
# where they get passed to nvcc without a -I prefix, breaking everything.  So please don't do it.

if(libbz2_ENABLED)
	add_definitions(-DHASBZ2)
	include_directories(${BZIP2_INCLUDE_DIR})
	targets_link_libraries(cpptraj libcpptraj LIBRARIES bzip2)
endif()

if(zlib_ENABLED)
	add_definitions(-DHASGZ)
	include_directories(${ZLIB_INCLUDE_DIRS})
	targets_link_libraries(cpptraj libcpptraj LIBRARIES ${ZLIB_LIBRARIES})
endif()

if(fftw_ENABLED)
	target_include_directories(cpptraj_common_obj PRIVATE $<TARGET_PROPERTY:fftw,INTERFACE_INCLUDE_DIRECTORIES>)	
	targets_link_libraries(cpptraj libcpptraj LIBRARIES fftw)
endif()

#readline
if(readline_ENABLED)
	targets_link_libraries(cpptraj libcpptraj LIBRARIES readline)
else()
	target_compile_definitions(cpptraj PRIVATE NO_READLINE)
	target_compile_definitions(libcpptraj PRIVATE NO_READLINE)
endif()

#xdrfile
targets_link_libraries(cpptraj libcpptraj LIBRARIES xdrfile)

# libsander
if(INSIDE_AMBER AND ("${AMBER_TOOLS}" MATCHES "sander" AND BUILD_SANDER_API))
	#add the sander-specific definitions and libraries
	target_compile_definitions(cpptraj PRIVATE USE_SANDERLIB)
	target_link_libraries(cpptraj libsander)
endif()


# arpack
if(arpack_DISABLED)
	add_definitions(-DNO_ARPACK)
endif()

# --------------------------------------------------------------------
# Parallel Versions
# --------------------------------------------------------------------

if(MPI)
	make_mpi_version(cpptraj_common_obj cpptraj_common_obj_mpi LANGUAGES CXX)
	make_mpi_version(cpptraj cpptraj.MPI LANGUAGES CXX SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj> TO $<TARGET_OBJECTS:cpptraj_common_obj_mpi> INSTALL)
	make_mpi_version(libcpptraj libcpptraj_mpi LANGUAGES CXX SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj> TO $<TARGET_OBJECTS:cpptraj_common_obj_mpi> INSTALL)
	
	set_property(TARGET cpptraj.MPI libcpptraj_mpi cpptraj_common_obj_mpi APPEND PROPERTY COMPILE_DEFINITIONS MPI) # since we use CXX mpi, we have to define this manually
			
	if(pnetcdf_ENABLED)
		targets_link_libraries(cpptraj.MPI libcpptraj_mpi LIBRARIES pnetcdf)
		target_include_directories(cpptraj_common_obj_mpi PUBLIC $<TARGET_PROPERTY:pnetcdf,INTERFACE_INCLUDE_DIRECTORIES>)
		set_property(TARGET cpptraj.MPI libcpptraj_mpi cpptraj_common_obj_mpi APPEND PROPERTY COMPILE_DEFINITIONS HAS_PNETCDF) 		
	endif()
endif()

if(OPENMP)
	make_openmp_version(cpptraj_common_obj cpptraj_common_obj_openmp LANGUAGES CXX)
	make_openmp_version(cpptraj cpptraj.OMP LANGUAGES CXX SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj> TO $<TARGET_OBJECTS:cpptraj_common_obj_openmp> INSTALL)
	make_openmp_version(libcpptraj libcpptraj_omp LANGUAGES CXX SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj> TO $<TARGET_OBJECTS:cpptraj_common_obj_openmp> INSTALL)
endif()

if(BUILD_PARALLEL_COMBINATIONS AND (MPI AND OPENMP))
	make_openmp_version(cpptraj_common_obj_mpi cpptraj_common_obj_mpi_openmp LANGUAGES CXX)
	make_openmp_version(cpptraj.MPI cpptraj.MPI.OMP LANGUAGES CXX SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj_mpi> TO $<TARGET_OBJECTS:cpptraj_common_obj_mpi_openmp> INSTALL)
	make_openmp_version(libcpptraj_mpi libcpptraj_mpi_omp LANGUAGES CXX SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj_mpi> TO $<TARGET_OBJECTS:cpptraj_common_obj_mpi_openmp> INSTALL)
endif()
	
# CUDA
if(CUDA)
	add_subdirectory(cuda_kernels)
	
	include_directories(${CUDA_INCLUDE_DIRS})
	
	copy_target(cpptraj_common_obj cpptraj_common_obj_cuda)
	target_compile_definitions(cpptraj_common_obj_cuda PRIVATE CUDA)
	
	copy_target(cpptraj cpptraj.cuda SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj> TO $<TARGET_OBJECTS:cpptraj_common_obj_cuda>)
	copy_target(libcpptraj libcpptraj_cuda SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj> TO $<TARGET_OBJECTS:cpptraj_common_obj_cuda>)
	
	target_compile_definitions(cpptraj.cuda PRIVATE CUDA)
	target_compile_definitions(libcpptraj_cuda PRIVATE CUDA)
	
	targets_link_libraries(cpptraj.cuda libcpptraj_cuda LIBRARIES cpptraj_cuda_routines)
	
	install(TARGETS cpptraj.cuda DESTINATION ${BINDIR} COMPONENT CUDA)
	
	if(BUILD_PARALLEL_COMBINATIONS AND MPI)
		make_mpi_version(cpptraj_common_obj_cuda cpptraj_common_obj_mpi_cuda LANGUAGES CXX)
		make_mpi_version(cpptraj.cuda cpptraj.MPI.cuda LANGUAGES CXX SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj_cuda> TO $<TARGET_OBJECTS:cpptraj_common_obj_mpi_cuda> INSTALL)
		make_mpi_version(libcpptraj_cuda libcpptraj_mpi_cuda LANGUAGES CXX SWAP_SOURCES $<TARGET_OBJECTS:cpptraj_common_obj_cuda> TO $<TARGET_OBJECTS:cpptraj_common_obj_mpi_cuda> INSTALL)
		
		set_property(TARGET cpptraj.MPI.cuda libcpptraj_mpi_cuda cpptraj_common_obj_mpi_cuda APPEND PROPERTY COMPILE_DEFINITIONS MPI) # since we use CXX mpi, we have to define this manually
				
		if(pnetcdf_ENABLED)
			targets_link_libraries(cpptraj.MPI.cuda libcpptraj_mpi_cuda LIBRARIES pnetcdf)
			target_include_directories(cpptraj_common_obj_mpi_cuda PUBLIC $<TARGET_PROPERTY:pnetcdf,INTERFACE_INCLUDE_DIRECTORIES>)
			set_property(TARGET cpptraj.MPI.cuda libcpptraj_mpi_cuda cpptraj_common_obj_mpi_cuda APPEND PROPERTY COMPILE_DEFINITIONS HAS_PNETCDF) 		
		endif()
	endif()

	if(BUILD_PARALLEL_COMBINATIONS AND OPENMP)

=== src/Makefile ===
# Cpptraj standalone Makefile
include ../config.h

include cpptrajfiles

DEL_FILE = /bin/rm -f

OBJECTS=$(SOURCES:.cpp=.o) $(CSOURCES:.c=.o)

# Default target: cpptraj only
all: cpptraj$(SFX)$(EXE)

# Install all targets
install: $(INSTALL_TARGETS)

# Cpptraj ------------------------------
install_cpptraj: cpptraj$(SFX)$(EXE)
	mv cpptraj$(SFX)$(EXE) $(CPPTRAJBIN)

cpptraj$(SFX)$(EXE): $(OBJECTS) $(FFT_TARGET) $(READLINE_TARGET) $(CUDA_TARGET) $(XDRFILE_TARGET) $(ARPACK_TARGET) $(TNGFILE_TARGET)
	$(CXX) -o cpptraj$(SFX)$(EXE) $(OBJECTS) $(CUDA_TARGET) $(FFT_TARGET) $(READLINE_LIB) $(CPPTRAJ_LIB) $(LDFLAGS)

# libcpptraj ---------------------------
# Rule to make libcpptraj-specific objects
%.LIBCPPTRAJ.o : %.cpp
	$(CXX) $(DIRECTIVES) -DLIBCPPTRAJ $(INCLUDE) $(CXXFLAGS) -c -o $@ $<

libcpptraj: $(LIBCPPTRAJ_TARGET)

$(CPPTRAJLIB)/libcpptraj$(SHARED_SUFFIX): $(LIBCPPTRAJ_OBJECTS) $(FFT_TARGET) $(CUDA_TARGET) $(XDRFILE_TARGET) $(ARPACK_TARGET) $(TNGFILE_TARGET)
	$(CXX) -shared -o $(CPPTRAJLIB)/libcpptraj$(SHARED_SUFFIX) $(LIBCPPTRAJ_OBJECTS) $(FFT_TARGET) $(CUDA_TARGET) $(CPPTRAJ_LIB) $(LDFLAGS)

# Data directory -----------------------
install_dat:
	cp ../dat/ATOMTYPE_CHECK.TAB $(CPPTRAJDAT)/
	cp ../dat/BONDTYPE_CHECK.TAB $(CPPTRAJDAT)/
	cp ../dat/Karplus.txt        $(CPPTRAJDAT)/
	cp ../dat/README             $(CPPTRAJDAT)/

# Static libraries ---------------------
#$(CPPTRAJLIB)/libcpptraj.a: $(LIBCPPTRAJ_OBJECTS) $(FFT_TARGET) $(CUDA_TARGET)
#	ar rv $(CPPTRAJLIB)/libcpptraj.a $(LIBCPPTRAJ_OBJECTS) $(FFT_TARGET) $(CUDA_TARGET)

$(CPPTRAJLIB)/libcpptraj_core.a: $(LIBCPPTRAJ_CORE_OBJECTS)
	ar rv $(CPPTRAJLIB)/libcpptraj_core.a $(LIBCPPTRAJ_CORE_OBJECTS)

$(CPPTRAJLIB)/libcpptraj_file.a: $(LIBCPPTRAJ_FILE_OBJECTS)
	ar rv $(CPPTRAJLIB)/libcpptraj_file.a $(LIBCPPTRAJ_FILE_OBJECTS)

$(CPPTRAJLIB)/libcpptraj_traj.a: $(LIBCPPTRAJ_TRAJ_OBJECTS) $(XDRFILE_OBJECTS) $(TNGFILE_OBJECTS) $(VMDPLUGIN_OBJECTS)
	ar rv $(CPPTRAJLIB)/libcpptraj_traj.a $(LIBCPPTRAJ_TRAJ_OBJECTS) $(XDRFILE_OBJECTS) $(TNGFILE_OBJECTS) $(VMDPLUGIN_OBJECTS)

$(CPPTRAJLIB)/libcpptraj_parm.a: $(LIBCPPTRAJ_PARM_OBJECTS)
	ar rv $(CPPTRAJLIB)/libcpptraj_parm.a $(LIBCPPTRAJ_PARM_OBJECTS)

libstatic: $(CPPTRAJLIB)/libcpptraj_core.a $(CPPTRAJLIB)/libcpptraj_traj.a \
           $(CPPTRAJLIB)/libcpptraj_file.a $(CPPTRAJLIB)/libcpptraj_parm.a

nolibcpptraj:
	@echo ""
	@echo "Error: Cannot build libcpptraj; re-configure with '-shared'"
	@echo ""
	@exit 1

# Internal object/library targets
pub_fft.o:  pub_fft.F90
	$(FC) $(FPPFLAGS) -c $(FFLAGS) -o $@ pub_fft.F90

readline/libreadline.a: ../external.config.h
	cd readline && $(MAKE) all

xdrfile/libxdrfile.a: ../external.config.h
	cd xdrfile && $(MAKE) all

arpack/libarpack.a: ../external.config.h
	cd arpack && $(MAKE) install

tng/libtng_io.a: ../external.config.h
	cd tng && $(MAKE) all

noreadline:
	@echo ""
	@echo "Skipping bundled READLINE build"
	@echo ""

noxdrfile:
	@echo ""
	@echo "Skipping bundled XDRFILE build"
	@echo ""

notngfile:
	@echo ""
	@echo "Skipping bundled TNG build"
	@echo ""

noarpack:
	@echo ""
	@echo "Skipping bundled ARPACK build"
	@echo ""

cuda_kernels/libcpptraj_cuda.a: ../external.config.h
	cd cuda_kernels && $(MAKE) all

# Dependency targets
findDepend: FindDepend.o 
	$(CXX) -o findDepend FindDepend.o

depend: findDepend
	./findDepend $(SOURCES) $(CSOURCES) > cpptrajdepend

dependclean:
	$(DEL_FILE) FindDepend.o findDepend

# Clean/uninstall targets
clean:
	$(DEL_FILE) $(OBJECTS) $(FFT_TARGET) cpptraj$(SFX) *.LIBCPPTRAJ.o libcpptraj$(SHARED_SUFFIX)
	cd readline && $(MAKE) clean
	cd xdrfile && $(MAKE) clean
	cd arpack && $(MAKE) clean
	cd cuda_kernels && $(MAKE) clean
	cd tng && $(MAKE) clean

uninstall_lib:
	$(DEL_FILE) $(CPPTRAJLIB)/*.a
	$(DEL_FILE) $(CPPTRAJLIB)/*.la
	$(DEL_FILE) $(CPPTRAJLIB)/*.so*
	$(DEL_FILE) $(CPPTRAJLIB)/*.settings
	$(DEL_FILE) -r $(CPPTRAJLIB)/cmake
	$(DEL_FILE) -r $(CPPTRAJLIB)/pkgconfig

uninstall_inc:
	$(DEL_FILE) $(CPPTRAJINC)/*.h
	$(DEL_FILE) $(CPPTRAJINC)/*.f
	$(DEL_FILE) $(CPPTRAJINC)/*.f03

uninstall: uninstall_lib uninstall_inc
	$(DEL_FILE) $(CPPTRAJBIN)/cpptraj$(SFX)$(EXE)
	$(DEL_FILE) $(CPPTRAJLIB)/libcpptraj$(SHARED_SUFFIX)
	cd readline && make uninstall
	cd xdrfile && make uninstall
	cd cuda_kernels && make uninstall

# Header dependencies
include cpptrajdepend

=== test/CMakeLists.txt ===

if(INSTALL_TESTS)
	if(INSIDE_AMBER)
		
		# install to full path inside AmberTools directory
		install(DIRECTORY . USE_SOURCE_PERMISSIONS DESTINATION AmberTools/src/cpptraj/test/ COMPONENT Tests)
	else()
		# install to top-level dir
		install(DIRECTORY . USE_SOURCE_PERMISSIONS DESTINATION test/ COMPONENT Tests)
	endif()
endif()

=== test/Makefile ===
# Test makefile for cpptraj
test: test.all 

test.general:
	@-cd Test_General && ./RunTest.sh $(OPT)
	@-cd Test_Parallel && ./RunTest.sh $(OPT)

test.strip:
	@-cd Test_Strip && ./RunTest.sh $(OPT)

test.brokentraj:
	@-cd Test_BrokenTraj && ./RunTest.sh $(OPT)

test.trajinoffset:
	@-cd Test_TrajinOffset && ./RunTest.sh $(OPT)

test.remdnetcdf:
	@-cd Test_RemdTraj && ./RunTest.sh $(OPT)

test.framerange:
	@-cd Test_trajout_framerange && ./RunTest.sh $(OPT)

test.perres:
	@-cd Test_PerResRMSD && ./RunTest.sh $(OPT)

test.dssp:
	@-cd Test_DSSP && ./RunTest.sh $(OPT)

test.center:
	@-cd Test_Center && ./RunTest.sh $(OPT)

test.hbond:
	@-cd Test_Hbond && ./RunTest.sh $(OPT)

test.image:
	@-cd Test_Image && ./RunTest.sh $(OPT)

test.netcdftraj:
	@-cd Test_NetcdfTraj && ./RunTest.sh $(OPT)

test.surf:
	@-cd Test_Surf && ./RunTest.sh $(OPT)

test.radgyr:
	@-cd Test_Radgyr && ./RunTest.sh $(OPT)

test.mask:
	@-cd Test_Mask && ./RunTest.sh $(OPT)

test.closest:
	@-cd Test_Closest && ./RunTest.sh $(OPT)

test.rmsd:
	@-cd Test_RMSD && ./RunTest.sh $(OPT)

test.outtraj:
	@-cd Test_Outtraj && ./RunTest.sh $(OPT)

test.datafile:
	@-cd Test_Datafile && ./RunTest.sh $(OPT)

test.avgref:
	@-cd Test_AvgRef && ./RunTest.sh $(OPT)

test.mol2:
	@-cd Test_Mol2 && ./RunTest.sh $(OPT)

test.nastruct:
	@-cd Test_NAstruct && ./RunTest.sh $(OPT)
	@-cd Test_NAstruct_8OG && ./RunTest.sh $(OPT)

test.pucker:
	@-cd Test_Pucker && ./RunTest.sh $(OPT)

test.atommap:
	@-cd Test_AtomMap && ./RunTest.sh $(OPT)

test.2drms:
	@-cd Test_2DRMS && ./RunTest.sh $(OPT)

test.average:
	@-cd Test_Average && ./RunTest.sh $(OPT)

test.radial:
	@-cd Test_Radial && ./RunTest.sh $(OPT)

test.hist:
	@-cd Test_Hist && ./RunTest.sh $(OPT)

test.ncrestart:
	@-cd Test_NCrestart && ./RunTest.sh $(OPT)

test.drmsd:
	@-cd Test_DRMSD && ./RunTest.sh $(OPT)

test.jcoupling:
	@-cd Test_Jcoupling && ./RunTest.sh $(OPT)

test.cluster:
	@-cd Test_Cluster && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_Sieve && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_RandomSieve && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_DataSet && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_DBSCAN && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_Kmeans && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_SymmRMSD && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_TrajWrites && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_Dpeaks && ./RunTest.sh $(OPT)
	@-cd Test_Cluster_Nreps && ./RunTest.sh $(OPT)

test.ired:
	@-cd Test_IRED && ./RunTest.sh $(OPT)

test.molsurf:
	@-cd Test_Molsurf && ./RunTest.sh $(OPT)

test.charmm:
	@-cd Test_Charmm && ./RunTest.sh $(OPT)
	@-cd Test_CharmmParams && ./RunTest.sh $(OPT)

test.rotdif:
	@-cd Test_Rotdif && ./RunTest.sh $(OPT)

test.corr:
	@-cd Test_Corr && ./RunTest.sh $(OPT)

test.checkstructure:
	@-cd Test_CheckStructure && ./RunTest.sh $(OPT)

test.runavg:
	@-cd Test_Runavg && ./RunTest.sh $(OPT)

test.analrunavg:
	@-cd Test_AnalysisRunAvg && ./RunTest.sh $(OPT)

test.rmsavgcorr:
	@-cd Test_RmsAvgCorr && ./RunTest.sh $(OPT)

test.contacts:
	@-cd Test_Contacts && ./RunTest.sh $(OPT)

test.principal:
	@-cd Test_Principal && ./RunTest.sh $(OPT)

test.clusterdihedral:
	@-cd Test_ClusterDihedral && ./RunTest.sh $(OPT)

test.vector:
	@-cd Test_Vector && ./RunTest.sh $(OPT)

test.matrix:
	@-cd Test_Matrix && ./RunTest.sh $(OPT)

test.atomicfluct:
	@-cd Test_AtomicFluct && ./RunTest.sh $(OPT)

test.grid:
	@-cd Test_Grid && ./RunTest.sh $(OPT)

test.unwrap:
	@-cd Test_Unwrap && ./RunTest.sh $(OPT)

test.project:
	@-cd Test_Project && ./RunTest.sh $(OPT)

test.analyzemodes:
	@-cd Test_Analyze_Modes && ./RunTest.sh $(OPT)

test.watershell:
	@-cd Test_Watershell && ./RunTest.sh $(OPT)

test.diffusion:
	@-cd Test_Diffusion && ./RunTest.sh $(OPT)

test.volmap:
	@-cd Test_Volmap && ./RunTest.sh $(OPT)

test.lie:
	@-cd Test_LIE && ./RunTest.sh $(OPT)

test.spam:
	@-cd Test_SPAM && ./RunTest.sh $(OPT)

test.randomizeions:
	@-cd Test_RandomizeIons && ./RunTest.sh $(OPT)

test.density:
	@-cd Test_Density && ./RunTest.sh $(OPT)

test.lipidorder:
	@-cd Test_LipidOrder && ./RunTest.sh $(OPT)
	@-cd Test_LipidSCD && ./RunTest.sh $(OPT)

test.pairdist:
	@-cd Test_PairDist && ./RunTest.sh $(OPT)

test.gist:
	@-cd Test_GIST && ./RunTest.sh $(OPT)
	@-cd Test_GIST_Order && ./RunTest.sh $(OPT)

test.readdata:
	@-cd Test_ReadData && ./RunTest.sh $(OPT)

test.systemVF:
	@-cd Test_systemVF && ./RunTest.sh $(OPT)

test.atomiccorr:
	@-cd Test_AtomicCorr && ./RunTest.sh $(OPT)

test.autocorr:
	@-cd Test_AutoCorr && ./RunTest.sh $(OPT)

test.box:
	@-cd Test_Box && ./RunTest.sh $(OPT)

test.atomtypeselect:
	@-cd Test_AtomTypeSelect && ./RunTest.sh $(OPT)

test.crankstat:
	@-cd Test_Crank_Stat && ./RunTest.sh $(OPT)

test.createcrd:
	@-cd Test_CreateCrd && ./RunTest.sh $(OPT)

test.autoimage:
	@-cd Test_AutoImage && ./RunTest.sh $(OPT)

test.loadcrd:
	@-cd Test_LoadCrd && ./RunTest.sh $(OPT)

test.multivector:
	@-cd Test_MultiVector && ./RunTest.sh $(OPT)

test.lifetime:
	@-cd Test_Lifetime && ./RunTest.sh $(OPT)

test.fft:
	@-cd Test_FFT && ./RunTest.sh $(OPT)

test.timecorr:
	@-cd Test_Timecorr && ./RunTest.sh $(OPT)

test.crosscorr:
	@-cd Test_CrossCorr && ./RunTest.sh $(OPT)

test.symmrmsd:
	@-cd Test_SymmRmsd && ./RunTest.sh $(OPT)

test.multidihedral:
	@-cd Test_Multidihedral && ./RunTest.sh $(OPT)

test.mremd:
	@-cd Test_Ensemble_MREMD && ./RunTest.sh $(OPT)

test.makestructure:
	@-cd Test_MakeStructure && ./RunTest.sh $(OPT)

test.rotate:
	@-cd Test_Rotate && ./RunTest.sh $(OPT)

test.integrate:
	@-cd Test_Integrate && ./RunTest.sh $(OPT)

test.nativecontacts:
	@-cd Test_NativeContacts && ./RunTest.sh $(OPT)

test.checkchirality:
	@-cd Test_CheckChiral && ./RunTest.sh $(OPT)

test.energy:
	@-cd Test_Energy && ./RunTest.sh $(OPT)

test.lessplit:
	@-cd Test_LESsplit && ./RunTest.sh $(OPT)

test.permutedih:
	@-cd Test_PermuteDihedrals && ./RunTest.sh $(OPT)

test.ccp4:
	@-cd Test_CCP4 && ./RunTest.sh $(OPT)

test.dihcovar:
	@-cd Test_DihCovar && ./RunTest.sh $(OPT)

test.curvefit:
	@-cd Test_CurveFit && ./RunTest.sh $(OPT)
	@-cd Test_Multicurve && ./RunTest.sh $(OPT)

test.datasetavg:
	@-cd Test_DataSetAverage && ./RunTest.sh $(OPT)

test.vectormath:
	@-cd Test_VectorMath && ./RunTest.sh $(OPT)

test.esander:
	@-cd Test_Esander && ./RunTest.sh $(OPT)
	@-cd Test_Esander_Short && ./RunTest.sh $(OPT)

test.temperature:
	@-cd Test_Temperature && ./RunTest.sh $(OPT)

test.spline:
	@-cd Test_Spline && ./RunTest.sh $(OPT)

test.kde:
	@-cd Test_KDE && ./RunTest.sh $(OPT)

test.wavelet:
	@-cd Test_Wavelet && ./RunTest.sh $(OPT)

test.cif:
	@-cd Test_CIF && ./RunTest.sh $(OPT)

test.pdb:
	@-cd Test_PDB && ./RunTest.sh $(OPT)

test.align:
	@-cd Test_Align && ./RunTest.sh $(OPT)

test.velocityautocorr:
	@-cd Test_VelocityAutoCorr && ./RunTest.sh $(OPT)

test.velfrc:
	@-cd Test_VelFrc && ./RunTest.sh $(OPT)

test.rotatedihedral:
	@-cd Test_RotateDihedral && ./RunTest.sh $(OPT)

test.dataset:
	@-cd Test_DataSetCmd && ./RunTest.sh $(OPT)

test.remap:
	@-cd Test_Remap && ./RunTest.sh $(OPT)

test.comparetop:
	@-cd Test_CompareTop && ./RunTest.sh $(OPT)

test.filter:
	@-cd Test_Filter && ./RunTest.sh $(OPT)

test.combinecrd:
	@-cd Test_CombineCrd && ./RunTest.sh $(OPT)

test.topinfo:
	@-cd Test_TopInfo && ./RunTest.sh $(OPT)

test.gromacs:
	@-cd Test_GromacsTrr && ./RunTest.sh $(OPT)
	@-cd Test_GromacsXtc && ./RunTest.sh $(OPT)
	@-cd Test_GromacsTNG && ./RunTest.sh $(OPT)

test.ewald:
	@-cd Test_Ewald && ./RunTest.sh $(OPT)
	@-cd Test_LibPME && ./RunTest.sh $(OPT)
	@-cd Test_LJ_PME && ./RunTest.sh $(OPT)

test.ti:
	@-cd Test_TI && ./RunTest.sh $(OPT)

test.fiximagedbonds:
	@-cd Test_FixImagedBonds && ./RunTest.sh $(OPT)

test.distance:
	@-cd Test_Distance && ./RunTest.sh $(OPT)

test.volume:
	@-cd Test_Volume && ./RunTest.sh $(OPT)

test.setvelocity:
	@-cd Test_SetVelocity && ./RunTest.sh $(OPT)

test.remlog:
	@-cd Test_Remlog && ./RunTest.sh $(OPT)

test.areapermol:
	@-cd Test_AreaPerMol && ./RunTest.sh $(OPT)

test.distbasedmask:
	@-cd Test_DistBasedMask && ./RunTest.sh $(OPT)

test.calc:
	@-cd Test_Calc && ./RunTest.sh $(OPT)

test.calcstate:
	@-cd Test_CalcState && ./RunTest.sh $(OPT)

test.change:
	@-cd Test_Change && ./RunTest.sh $(OPT)

test.createreservoir:
	@-cd Test_CreateReservoir && ./RunTest.sh $(OPT)

test.fixatomorder:
	@-cd Test_FixAtomOrder && ./RunTest.sh $(OPT)

test.lowestcurve:
	@-cd Test_LowestCurve && ./RunTest.sh $(OPT)

test.minimage:
	@-cd Test_MinImage && ./RunTest.sh $(OPT)

test.regress:
	@-cd Test_Regress && ./RunTest.sh $(OPT)

test.rst:
	@-cd Test_Rst && ./RunTest.sh $(OPT)

test.pairwise:
	@-cd Test_Pairwise && ./RunTest.sh $(OPT)

test.parmbox:
	@-cd Test_ParmBox && ./RunTest.sh $(OPT)

test.solvent:
	@-cd Test_Solvent && ./RunTest.sh $(OPT)

test.translate:
	@-cd Test_Translate && ./RunTest.sh $(OPT)

test.replicatecell:
	@-cd Test_ReplicateCell && ./RunTest.sh $(OPT)

test.scaledihedralk:
	@-cd Test_ScaleDihedralK && ./RunTest.sh $(OPT)

test.phipsi:
	@-cd Test_PhiPsi && ./RunTest.sh $(OPT)

test.control:
	@-cd Test_Control && ./RunTest.sh $(OPT)

test.infraredspec:
	@-cd Test_InfraredSpec && ./RunTest.sh $(OPT)

test.cphstats:
	@-cd Test_Cphstats && ./RunTest.sh $(OPT)

test.cmdline:
	@-cd Test_CmdLine && ./RunTest.sh $(OPT)

test.xyzfmt:
	@-cd Test_XYZformat && ./RunTest.sh $(OPT)

test.hausdorff:
	@-cd Test_Hausdorff && ./RunTest.sh $(OPT)

test.catcrd:
	@-cd Test_CatCrd && ./RunTest.sh $(OPT)

test.xtalsymm:
	@-cd Test_XtalSymm && ./RunTest.sh $(OPT)

test.time:
	@-cd Test_Time && ./RunTest.sh $(OPT)

test.splitcoords:
	@-cd Test_SplitCoords && ./RunTest.sh $(OPT)

test.dihedralrms:
	@-cd Test_DihedralRMS && ./RunTest.sh $(OPT)

test.slope:
	@-cd Test_Slope && ./RunTest.sh $(OPT)

test.diagmatrix:
	@-cd Test_Diagmatrix && ./RunTest.sh $(OPT)

test.emin:
	@-cd Test_Emin && ./RunTest.sh $(OPT)

test.evalplateau:
	@-cd Test_EvalPlateau && ./RunTest.sh $(OPT)

test.graft:
	@-cd Test_Graft && ./RunTest.sh $(OPT)

test.flatten:
	@-cd Test_Flatten && ./RunTest.sh $(OPT)

test.random:
	@-cd Test_Random && ./RunTest.sh $(OPT)

# Every test target should go here.
COMPLETETESTS=test.general \
              test.strip \
              test.brokentraj \
              test.trajinoffset \
              test.remdnetcdf \
              test.framerange \
              test.perres \
              test.dssp \
              test.center \
              test.hbond \
              test.ncrestart \
              test.image \
              test.surf \
              test.radgyr \
              test.mask \
              test.jcoupling \
              test.diffusion \
              test.outtraj \
              test.charmm \
              test.rotdif \
              test.netcdftraj \
              test.runavg \
              test.rmsd \
              test.2drms \
              test.mol2 \
              test.nastruct \
              test.average \
              test.pucker \
              test.atommap \
              test.datafile \
              test.radial \
              test.hist \
              test.closest \
              test.drmsd \
              test.cluster \
              test.ired \
              test.randomizeions \
              test.molsurf \
              test.corr \
              test.checkstructure \
              test.rmsavgcorr \
              test.contacts \
              test.principal \
              test.clusterdihedral \
              test.vector \
              test.matrix \
              test.atomicfluct \
              test.grid \
              test.unwrap \
              test.project \
              test.analyzemodes \
              test.watershell \
              test.analrunavg \
              test.volmap \
              test.spam \
              test.lie \
              test.density \
              test.lipidorder \
              test.pairdist \
              test.readdata \
              test.gist \
              test.systemVF \
              test.atomiccorr \
              test.autocorr \
              test.box \
              test.atomtypeselect \
              test.avgref \

=== unitTests/Makefile ===
# Makefile for unit tests

test: test.all

# ----- All unit tests go below ------------------

unit.NameType:
	@-cd NameType && ./UnitTest.sh $(OPT)

unit.ArgList:
	@-cd ArgList && ./UnitTest.sh $(OPT)

# ----- Every unit test should go here -----------
COMPLETETESTS= \
  unit.NameType \
  unit.ArgList

test.cpptraj: $(COMPLETETESTS)

# ------------------------------------------------

test.complete: CpptrajTest.sh UnitMaster.sh
	@./CpptrajTest.sh --target test.cpptraj $(OPT)

test.all:
	$(MAKE) test.complete summary

test.showerrors:
	$(MAKE) test.complete summary OPT="$(OPT) showerrors"

summary: CpptrajTest.sh UnitMaster.sh 
	@./CpptrajTest.sh summary $(OPT)

clean:
	@echo "Cleaning unit tests."
	$(MAKE) test.complete OPT=clean

=== devtools/rngtest/Makefile ===
include ../../config.h

#OBJECTS=rngtest.o Random.o RNG.o RNG_Stdlib.o RNG_Marsaglia.o CpptrajStdio.o RNG_MersenneTwister.o RNG_PCG32.o xoshiro128plusplus.o RNG_Xoshiro128pp.o
SOURCES=rngtest.cpp ../../src/RNG_MersenneTwister.cpp ../../src/RNG.cpp ../../src/CpptrajStdio.cpp ../../src/Random.cpp ../../src/RNG_Stdlib.cpp ../../src/RNG_Marsaglia.cpp ../../src/RNG_PCG32.cpp ../../src/RNG_Xoshiro128pp.cpp ../../src/xoshiro128plusplus.cpp

all: rngtest

debug:
	make CXXFLAGS='-O0 -g' CFLAGS='-O0 -g' rngtest

rngtest: $(SOURCES) 
	$(CXX) $(DIRECTIVES) $(CXXFLAGS) -o rngtest $(SOURCES) 

clean:
	/bin/rm -f  rngtest

rngtest.o: rngtest.cpp
	$(CXX) $(CXXFLAGS) -c -o rngtest.o rngtest.cpp

Random.o: ../../src/Random.cpp
	$(CXX) $(CXXFLAGS) -c -o Random.o ../../src/Random.cpp

RNG.o: ../../src/RNG.cpp
	$(CXX) $(CXXFLAGS) -c -o RNG.o ../../src/RNG.cpp

RNG_Stdlib.o: ../../src/RNG_Stdlib.cpp
	$(CXX) $(CXXFLAGS) -c -o RNG_Stdlib.o ../../src/RNG_Stdlib.cpp

RNG_Marsaglia.o: ../../src/RNG_Marsaglia.cpp
	$(CXX) $(CXXFLAGS) -c -o RNG_Marsaglia.o ../../src/RNG_Marsaglia.cpp

RNG_MersenneTwister.o: ../../src/RNG_MersenneTwister.cpp
	$(CXX) $(DIRECTIVES) $(CXXFLAGS) -c -o RNG_MersenneTwister.o ../../src/RNG_MersenneTwister.cpp

RNG_PCG32.o: ../../src/RNG_PCG32.cpp
	$(CXX) $(CXXFLAGS) -c -o RNG_PCG32.o ../../src/RNG_PCG32.cpp

CpptrajStdio.o: ../../src/CpptrajStdio.cpp
	$(CXX) $(CXXFLAGS) -c -o CpptrajStdio.o ../../src/CpptrajStdio.cpp

RNG_Xoshiro128pp.o: ../../src/RNG_Xoshiro128pp.cpp
	$(CXX) $(CXXFLAGS) -c -o RNG_Xoshiro128pp.o ../../src/RNG_Xoshiro128pp.cpp

xoshiro128plusplus.o: ../../src/xoshiro128plusplus.cpp
	$(CXX) $(CXXFLAGS) -c -o xoshiro128plusplus.o ../../src/xoshiro128plusplus.cpp

=== devtools/testu01/Makefile ===
include ../../config.h

TESTU01_DIR=$(TESTU01_HOME)

#AR= ar cqs

#CXX=g++
CXXFLAGS += -I../../src

SOURCES=cpptraj_rng.cpp RNG_MersenneTwister.cpp RNG.cpp CpptrajStdio.cpp Random.cpp RNG_Stdlib.cpp RNG_Marsaglia.cpp RNG_PCG32.cpp RNG_Xoshiro128pp.cpp xoshiro128plusplus.cpp

OBJECTS=$(SOURCES:.cpp=.o)

all: a.out

main.o: main.c
	$(CC) -c -o main.o -Wall -O3 -I$(TESTU01_DIR)/include main.c

#cpptraj.a: $(OBJECTS)
#	-/bin/rm -f cpptraj.a
#	$(AR) cpptraj.a $(OBJECTS)

a.out: $(OBJECTS) main.o
	$(CXX) -o a.out main.o $(OBJECTS) -L$(TESTU01_DIR)/lib -ltestu01 -lprobdist -lmylib -lm
#	gcc -std=c99 -Wall -O3 -o a.out cpptraj.a -L$(TESTU01_DIR)/lib -ltestu01 -lprobdist -lmylib -lm

clean:
	-/bin/rm *.o a.out

=== src/cuda_kernels/CMakeLists.txt ===
set(CPPTRAJ_CUDA_SOURCES core_kernels.cu kernel_wrappers.cu GistCudaCalc.cu GistCudaSetup.cu)

cuda_add_library(cpptraj_cuda_routines ${CPPTRAJ_CUDA_SOURCES})

install_libraries(cpptraj_cuda_routines)

=== src/cuda_kernels/Makefile ===
# Makefile for cpptraj cuda sources
include ../../external.config.h

# Variables
DEL_FILE      = /bin/rm -f
AR            = ar cqs
TARGET        = libcpptraj_cuda.a

# General rules

# Source files

CUDA_SOURCES=core_kernels.cu kernel_wrappers.cu GistCudaCalc.cu GistCudaSetup.cu

# Objects

OBJECTS=$(CUDA_SOURCES:.cu=.o)

# Specific rules

all: $(TARGET)

$(TARGET): $(OBJECTS)
	-$(DEL_FILE) $(TARGET)
	$(AR) $(TARGET) $(OBJECTS)

clean:
	$(DEL_FILE) *.o $(TARGET)

uninstall: clean

# Dependencies
core_kernels.o: core_kernels.cu

kernel_wrappers.o: kernel_wrappers.cu

=== src/tng/Makefile ===
# Makefile for TNG bundled with cpptraj
include ../../external.config.h

CFLAGS += -I . $(ZLIB_INCL)

# Variables
DEL_FILE      = /bin/rm -f
AR            = ar cqs
TARGET        = libtng_io.a

# Source files
SOURCES=md5.c tng_io.c tng_compress.c coder.c warnmalloc.c fixpoint.c xtc3.c bwlzh.c xtc2.c widemuldiv.c huffmem.c vals16.c bwt.c mtf.c rle.c lz77.c dict.c huffman.c merge_sort.c

# Objects
OBJECTS=$(SOURCES:.c=.o)

# Specific rules

all: $(TARGET)

$(TARGET): $(OBJECTS)
	-$(DEL_FILE) $(TARGET)
	$(AR) $(TARGET) $(OBJECTS)

test: $(TARGET) tng_io_testing.o tng_example.tng
	$(CC) -o a.out tng_io_testing.c $(TARGET) -lm $(ZLIB_FLAG)
	./a.out

clean:
	$(DEL_FILE) *.o $(TARGET) tng_io_testing.o a.out tng_example_out.tng tng_test.tng

uninstall: clean

# Dependencies
md5.o : md5.c tng/md5.h

tng_io.o : tng_io.c tng/tng_io.h tng/tng_io_fwd.h compression/tng_compress.h tng/version.h

tng_compress.o : tng_compress.c compression/tng_compress.h compression/coder.h compression/fixpoint.h

coder.o : coder.c compression/coder.h compression/tng_compress.h compression/bwlzh.h compression/warnmalloc.h

warnmalloc.o : warnmalloc.c compression/warnmalloc.h compression/tng_compress.h

fixpoint.o : fixpoint.c compression/fixpoint.h 

xtc3.o : xtc3.c compression/warnmalloc.h compression/bwlzh.h compression/widemuldiv.h

bwlzh.o : bwlzh.c compression/bwlzh.h compression/warnmalloc.h compression/tng_compress.h compression/dict.h compression/vals16.h compression/rle.h compression/mtf.h compression/bwt.h compression/lz77.h

xtc2.o : xtc2.c compression/coder.h compression/widemuldiv.h compression/warnmalloc.h

widemuldiv.o : widemuldiv.c compression/widemuldiv.h compression/tng_compress.h compression/my64bit.h

huffmem.o : huffmem.c compression/huffman.h compression/warnmalloc.h compression/tng_compress.h compression/bwlzh.h compression/dict.h compression/rle.h compression/vals16.h

vals16.o : vals16.c compression/vals16.h

bwt.o : bwt.c compression/bwt.h compression/warnmalloc.h

mtf.o : mtf.c compression/mtf.h compression/warnmalloc.h

rle.o : rle.c compression/rle.h

lz77.o : lz77.c compression/lz77.h compression/bwt.h compression/warnmalloc.h

dict.o : dict.c compression/dict.h

huffman.o : huffman.c compression/warnmalloc.h compression/merge_sort.h compression/huffman.h

merge_sort.o : merge_sort.c compression/merge_sort.h compression/warnmalloc.h

=== src/xdrfile/CMakeLists.txt ===
#AMBER CMake buildfile for xdrfile.
set(XDRFILE_SOURCES xdrfile.c xdr_seek.c xdrfile_trr.c xdrfile_xtc.c)

#------------------------------------------------------------------------------------------
#I assume that this library should be optimized
add_compile_options(${OPT_CFLAGS})

if("${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC")
	# xdrfile is not set up to build as a Windows shared library.  Someone would need to add dll exports to all of the symbols (bluh)
	add_library(xdrfile STATIC ${XDRFILE_SOURCES})
else()
	add_library(xdrfile ${XDRFILE_SOURCES})
endif()

target_include_directories(xdrfile PUBLIC .)
install_libraries(xdrfile)

=== debian/changelog ===
cpptraj (5.1.0+dfsg-5) unstable; urgency=medium

  * Team upload.
  [ Adrian Bunk ]
  * Fix FTBFS with GCC 15. Closes: #1096471.
  [ Santiago Vila ]
  * Add debian/salsa-ci.yml.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Sun, 21 Sep 2025 23:20:00 +0200

cpptraj (5.1.0+dfsg-4) unstable; urgency=medium

  * Stop the build on test failures.
  * Build with OpenMM support on armhf, mips64el and riscv64 as well.
  * Bump copyright years.

 -- Andrius Merkys <merkys@debian.org>  Mon, 13 May 2024 10:39:49 -0400

=== debian/control ===
Source: cpptraj
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 gfortran,
 libarpack2-dev,
 libbz2-dev,
 libfftw3-dev,
 libnetcdf-dev,
 libopenmm-dev [amd64 arm64 armhf mips64el ppc64el riscv64],
 libreadline-dev,
 netcdf-bin <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://github.com/Amber-MD/cpptraj
Vcs-Browser: https://salsa.debian.org/debichem-team/cpptraj
Vcs-Git: https://salsa.debian.org/debichem-team/cpptraj.git

Package: cpptraj
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: fast, parallelized molecular dynamics trajectory data analysis
 CPPTRAJ is a program designed to process and analyze molecular dynamics
 trajectories and relevant data sets derived from their analysis. CPPTRAJ
 supports many popular MD software packages including Amber, CHARMM, Gromacs,
 and NAMD.

=== debian/rules ===
#!/usr/bin/make -f

CONFIGURE_OPTIONS = --with-arpack=/usr/lib/$(DEB_HOST_MULTIARCH) --with-fftw3=/usr/lib/$(DEB_HOST_MULTIARCH) --with-readline=/usr/lib/$(DEB_HOST_MULTIARCH)

ifeq ($(shell test -e /usr/include/OpenMM.h && echo YES),YES)
	CONFIGURE_OPTIONS += --with-openmm=/usr/lib/$(DEB_HOST_MULTIARCH)
endif

%:
	dh $@

override_dh_auto_configure:
	./configure gnu $(CONFIGURE_OPTIONS)

override_dh_auto_test:
	dh_auto_test -- check unittest
	$(MAKE) -C test summary

override_dh_auto_clean:
	touch config.h external.config.h
	dh_auto_clean
	rm -rf bin

# Manpage generation is supposed to be run manually after the binary
# package has been built and installed on the system.
debian/cpptraj.1:
	help2man cpptraj --no-discard-stderr --no-info --name 'fast, parallelized molecular dynamics trajectory data analysis' > $@

=== debian/tests/control ===
Test-Command: mkdir bin && ln -s /usr/bin/cpptraj bin && make -C test test.complete summary
Depends:
 @,
 netcdf-bin, 
Restrictions:
 rw-build-tree,

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,repack,repacksuffix=+dfsg,dversionmangle=auto" \
 https://github.com/Amber-MD/cpptraj/tags \
 (?:.*?/)?v?(\d+\.\d+\.\d+)@ARCHIVE_EXT@
